% Comparing minave with minimax
clc;
clear all;
global N;
global n;
%global x;
global betta;
global bett2;
global Z;
global U;
global D;
global p;
global Dinv;
global obspt;
global traject;
global trajectx;
global f_bias;
global f_var;
global f_loss;
global f_classic;
global f_lossx;
global div;
global div2;
global maxite1;
global maxite2;
global maxitex;
global n_star;
global alpha;
global store;
global pt;
global ind2;
global ind1;
global Jplusfixed;
global firstloss;
global firstvnot;
global sym;
global type; %indicator for design type (minave or minimax)


N = 40;
obspt = [20];
x = -1:(2/(N-1)):1;
% fout1 = fopen('ave_max.dat','a');
rho = [1 .95 .75 .5 .25 0];
robmax = [];
robave = [];
premmax = [];
premave= [];
typ = [0 1];
for m = 1:length(typ)
    type = typ(m);
    for f = 1:length(rho)
        div = 50;
        div2 = 50;
        maxite1 =10000;
        maxite2 = 1;
        bett2 = 1e-4;
        for j = 1:length(obspt)
            n = obspt(j);
            betta = 1;
            Z = [ones(1,N);x;x.^2;x.^3]';
            dim = size(Z);
            p = dim(2);
            [U,D,V] = svd(Z,0);
            %         x1=svdcomp(x);
            sym = 1;
            if (sym==1)
                if (n<N) v = repmat([1 zeros(1,N/n-1)],1,n/2);
                else v = repmat(n/N,1,N/2);
                end;
                %             v = inivecsym(N,n,p);
                store = sim_optim(v,rho(f));
                ind1 = find(store>0);
            else
                %             if (n<N) v = repmat([1 zeros(1,N/n-1)],1,n);
                %             else v = repmat(n/N,1,N);
                %             end;
                v = inivec(N,n,p);
                store = sim_optim(v,rho(f));
                ind1 = find(store>0);
                pt = [ind1];
                x_star = x(pt);
                s = [store(ind1)];
            end;
            if (f==1) f_classic = f_loss; store_classic = store; end;
            [prem rob] = premrob(store_classic,store,rho(f));
            if (type==0) 
                premave(f) = prem;
                robave(f) = rob;
            else
                premmax(f) = prem;
                robmax(f) = rob;
            end;
        end;
    end;
end;

h = figure('Visible','On');
plot(rho,robave,'-b*'); ylim([0,100]);xlabel('Design Parameter (\rho)'); ylabel('Premium and Robustness Gain (%)'); title('Comparing Minimax and Minave Designs using Premium and Robustness Gain')
hold on;
plot(rho,premave,'-bo');
hold on;
plot(rho,robmax,'--r*');
hold on;
plot(rho,premmax,'--ro');
h = legend('Minave - Robustness Gain','Minave - Premium Paid','Minimax - Robustness Gain','Minimax - Premium Paid',1);
% fclose(fout1);

