function [prem rob] = premrob(store_classic, store,g)

global f_loss;
global f_classic;
global n;
global N;
global x;
global B;
global mcn;
global tau;
global p;
global U;
global D;
global V;
global type;
global sym;

rho = tau;
if (sym==1)
    w = [store_classic fliplr(store_classic)];
else w = store_classic;
end;
P = diag(w/n);
M2 = U'*(P^2)*U;
M1 = U'*P*U;
M1inv = inv(M1);
varia = trace(M1inv)/N; %minave
if (type==0)
    bias = 1 + (trace(M1inv*M2*M1inv)-p)/(N-p); %minave
else 
    bias = max(eig(M1inv*M2*M1inv)); %minimax
end;
obj = g*varia + (1-g)*bias;
rob = (1 - f_loss/obj)*100;

if (sym==1)
    w = [store fliplr(store)];
else w = store;
end;
P = diag(w/n);
M2 = U'*(P^2)*U;
M1 = U'*P*U;
M1inv = inv(M1);
obj = trace(M1inv)/N; 
prem = (obj/f_classic - 1)*100;